#pragma once

#include "components.hpp"
#include "dinkyecs.hpp"
#include "tser.hpp"
#include <string>
#include <map>

namespace save {

  struct Facts {
    components::Player player;

    DEFINE_SERIALIZABLE(Facts, player);
  };

  struct SaveData {
    Facts facts;

    std::map<DinkyECS::Entity, components::Position> position;
    std::map<DinkyECS::Entity, components::Motion> motion;
    std::map<DinkyECS::Entity, components::Combat> combat;

    DEFINE_SERIALIZABLE(SaveData, facts, position, motion, combat);
  };

  void to_file(std::string path, DinkyECS::World &world);
  void from_file(std::string path, DinkyECS::World &world_out);
  void load_configs(DinkyECS::World &world);
}
